#include <iostream>
using namespace std;

template <class T>
class dynamicarray
{
    int Size;
    T *Array;
public:    
    dynamicarray (int s=0)
    {
        Size = s;
        if (Size > 0) Array = new T[Size];
    };
    ~dynamicarray ()
    {
        if (Size > 0) delete[] Array;
    };
    void append (const T &value)
    {
        T *tmparray = new T[Size+1];
        for (int i=0; i<Size; i++) tmparray[i] = Array[i];
        tmparray[Size] = value;
        Size++;
        Array = tmparray;
    };
    void print ()
    {
        for (int i=0; i<Size; i++) cout << Array[i] << endl;
    };
    T& operator[] (int i) { return Array[i]; };
};
typedef dynamicarray<int> intarray;
typedef dynamicarray<string> stringarray;

int main ()
{
    intarray arri(2);
    arri[0] = 11;
    arri[1] = 22;
    arri.append (33);
    arri.print ();
    stringarray arrs;
    arrs.append ("Hello,");
    arrs.append ("Word!");
    arrs.print ();
    return 0;
}
